class OrigEntry {
    Object element;
    OrigEntry previous, next;

    OrigEntry( Object o, OrigEntry p, OrigEntry n ) {
	element = o;
	previous = p;
	next = n;
    }
}



public class OrigLinkedList {
    private OrigEntry header;
    private int size;

    public OrigLinkedList() {
	header = new OrigEntry(null, null, null);
	header.next = header;
	header.previous = header;

	size = 0;
    }

    public void add( Object o ) {
	OrigEntry newE = new OrigEntry( o, header, header.next );

	header.next.previous = newE;
	header.next = newE;

	++size;
    }

    public Object get( int idx ) {
	if( idx > size ) return null;

	OrigEntry e = header.next;

	for( int i=0; i<idx; ++i ) {
	    e = e.next;
	}

	return e.element;
    }


    public OrigReadIterator getReadIterator() {
	return new OrigReadIterator( header );
    }

    public OrigDeleteIterator getDeleteIterator() {
	return new OrigDeleteIterator( header );
    }


    public static void main( String[] args ) {

	OrigLinkedList ll = new OrigLinkedList();

	ll.add( new Integer(20) );
	ll.add( "xyz" );
	ll.add( new Float(2.2f) );
	ll.add( "Hello World" );
	ll.add( new Object() );

	OrigReadIterator itr = ll.getReadIterator();

	int i = 0;
	while( itr.hasNext() ) {
	    itr.moveNext();
	    System.out.println("Element[" + i + "]: " + itr.element() );
	    ++i;
	}

	OrigDeleteIterator itd = ll.getDeleteIterator();
	itd.moveNext();
	itd.moveNext();
	itd.delete();
	System.out.println("Deleted second element.");
	
	itr = ll.getReadIterator();

	i = 0;
	while( itr.hasNext() ) {
	    itr.moveNext();
	    System.out.println("Element[" + i + "]: " + itr.element() );
	    ++i;
	}

    }

}
