import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class GuiResetController implements java.util.Observer {


    public void update( java.util.Observable source, Object event ) {

	if( ! (event instanceof ChangeEvent) ) return;

	ChangeEvent ce = (ChangeEvent) event;

	if( ce instanceof IncreaseEvent ) {
	    button.setForeground( Color.RED );
	} else {
	    button.setForeground( Color.BLUE );
	}

	button.setText("Reset from: " + ce.getValue() );
    }


    private ActiveValue theValue;

    private JButton button;


    public Component createComponents() {

        JPanel pane = new JPanel();
        pane.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        30, //bottom
                                        30) //right
                                        );
        pane.setLayout(new BorderLayout());

	button = new JButton();
	button.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    theValue.reset();
		}
	    } );

        pane.add(button, BorderLayout.CENTER);

        return pane;
    }



    public GuiResetController(ActiveValue val) {

	theValue = val;

	try {
	    UIManager.setLookAndFeel(
		       UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) { }


        JFrame frame = new JFrame("Active Value Resetter");

        Component contents = createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.pack();
	frame.setSize( 300, 150 );


        frame.setVisible(true);
    }

}
