package client;

import java.rmi.*;
import java.io.*;


import common.ExeServer;
import common.Executable;

public class ExeClient {

    public static byte[] getBytecode( String name ) {
        byte[] bytecode = null;

        try {
	  String cs_path = name.replace('.', '/') + ".class";
	  FileInputStream fis = new FileInputStream( cs_path );
	  byte[] buf = new byte[10000];
	  int len = fis.read( buf );

          bytecode = new byte[ len ];
          System.arraycopy( buf, 0, bytecode, 0, len );
        } catch( Exception e ) {
          System.err.println("Error reading bytecode!");
          e.printStackTrace();
        }

	return bytecode;
    }


    public static void main( String[] args ) {
	if( args.length != 2 ) {
	    System.err.println("Usage: java ExeClient Executable Param");
	    System.exit(10);
	}

	String url = "rmi://localhost/ExeServer";

	try {
            ExeServer es = (ExeServer) Naming.lookup( url );

	    String cs_name = args[0];

	    byte[] bytecode = getBytecode( cs_name );

	    Object res = es.execute( cs_name, bytecode, args[1] );

	    System.out.println("Result: " + res );

        } catch( Exception e ) {
            System.err.println("Client had a problem...");
            e.printStackTrace();
        }
    }
}
