package server;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import common.ExeServer;
import common.Executable;


public class ExeServerImpl extends UnicastRemoteObject
    implements ExeServer {

    private ServerClassLoader cl;

    public ExeServerImpl() throws java.rmi.RemoteException {
	cl = new ServerClassLoader();
    }

    public Object execute( String name, byte[] code, Object param )
	throws RemoteException
    {
	cl.setBytecode( name, code );
	Executable exe = null;

	try {
	    exe = (Executable) cl.loadClass( name ).newInstance();
	} catch( Exception e ) {
	    throw new RemoteException( "loadClass problem!", e );
	}

	return exe.run( param );
    }

    public static void main( String[] args ) {
	try {
            Naming.rebind( "ExeServer", new ExeServerImpl( ) );
        } catch( Exception ex ) {
            System.err.println("Binding the server failed!");
            ex.printStackTrace();
        }
    }
}
