import java.lang.reflect.*;

public class ActiveValue extends MethodObservable {

    public void run() {
	int change;
	java.util.Random crnd = new java.util.Random();
	java.util.Random wrnd = new java.util.Random();

	myval = 0;

	while( true ) {
	    change = crnd.nextInt( 11 ) - 5;
	    
	    myval += change;

	    sendEvent( change );

	    try {
		Thread.sleep( wrnd.nextInt( 1000 ) );
	    } catch( InterruptedException ex ) {
		System.err.println("Exception: " + ex);
	    }
	}
    }


    public void reset() {
	setValue( 0 );
    }


    public void setValue( int value ) {
	int change;

	change = value - myval;
	myval = value;

	sendEvent( change );
    }


    public void sendEvent( int change ) {
	java.util.EventObject e;

	if( change >= 0 ) {
	    e = new IncreaseEvent(this, myval, change);
	} else {
	    e = new DecreaseEvent(this, myval, change);
	}

	notifyObservers( e );
    }

    protected void handleException( Object target, Method m, Exception e ) {
	if( e instanceof IllegalAccessException ) {
	    System.err.println("Illegal access to the method!");
	} else if( e instanceof IllegalArgumentException ) {
	    System.err.println("Illegal arguments to the method!");
	} else if( e instanceof InvocationTargetException ) {
	    System.err.println("Illegal invocation target!");
	} else {
	    System.err.println("Exception of type: " + e.getClass());
	}
	System.err.println("Target: " + target);
	System.err.println("Method: " + m);
	e.printStackTrace();
    }

    private int myval;
}
